// PekechatDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Pekechat.h"
#include "PekechatDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#include "ConnectionDlg.h"

// Client messages (from client to server)
#define CMSG_CONNECTION_REQUEST	1
#define CMSG_NICK_SEND					2
#define CMSG_TEXT								3
#define CMSG_DISCONNECT					4

// Server messages (from server to client)
#define SMSG_CONNECTION_ACCEPTED	1
#define SMSG_CONNECTION_DENIED		2
#define SMSG_NEW_USER							3
#define SMSG_USER_LOST						4
#define SMSG_TEXT									5
#define SMSG_NICK_ACCEPTED				6
#define SMSG_NICK_DENIED					7
#define SMSG_USER_QUIT						8
#define SMSG_SERVER_OFF						9
#define SMSG_KICKED								10
#define SMSG_USER_KICKED					11


class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


CPekechatDlg::CPekechatDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPekechatDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPekechatDlg)
	m_TextWindow = _T("");
	m_PromptText = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

	Connected = false;
}

void CPekechatDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPekechatDlg)
	DDX_Control(pDX, IDC_USER_LIST, m_NickList);
	DDX_Text(pDX, IDC_TEXT_DISPLAY, m_TextWindow);
	DDV_MaxChars(pDX, m_TextWindow, 1000000);
	DDX_Text(pDX, IDC_PROMPT_TEXT, m_PromptText);
	DDV_MaxChars(pDX, m_PromptText, 500);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CPekechatDlg, CDialog)
	//{{AFX_MSG_MAP(CPekechatDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_SEND, OnSend)
	ON_BN_CLICKED(IDC_CONECTION, OnConection)
	ON_WM_TIMER()
	ON_LBN_DBLCLK(IDC_USER_LIST, OnDblclkUserList)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPekechatDlg message handlers

BOOL CPekechatDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	m_TextWindow.Empty ();
	m_PromptText.Empty ();

	m_TextWindow = "Pekechat 1.0 Creado en 2002 por AK47\r\n";

	UpdateData (FALSE);

	UserCount = 0;
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CPekechatDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CPekechatDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CPekechatDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CPekechatDlg::OnSend() 
{
	UpdateData ();
	char Str [MSG_SIZE];
	CEdit *pEdit;
	char Msg [200];

	if (Connected)
	{
		memset (Str, 0, MSG_SIZE);

		strcpy (&Str [1], NickName);
		strcat (&Str [1], "> ");
		memcpy (&Str [1 + NickName.GetLength () + 2], m_PromptText, MSG_SIZE - 1 - (1 + NickName.GetLength () + 2));

		if (IsServer)
		{
			Str [0] = SMSG_TEXT;
			if (Connection.SendAllClients (Str) != 0)
			{
				wsprintf (Msg, "%s", Connection.GetErrorMsg ());
				SystemMsg (Msg);
			}
			m_TextWindow += &Str [1];
			m_TextWindow += "\r\n";
		}
		else
		{
			Str [0] = CMSG_TEXT;
			if (Connection.SendToServer (Str) != 0)
			{
				wsprintf (Msg, "%s", Connection.GetErrorMsg ());
				SystemMsg (Msg);
			}
		}

		m_PromptText.Empty ();
		UpdateData (FALSE);

		pEdit = (CEdit *)GetDlgItem (IDC_TEXT_DISPLAY);
		pEdit -> SetSel (m_TextWindow.GetLength (), m_TextWindow.GetLength ());

		GetDlgItem (IDC_PROMPT_TEXT) -> SetFocus ();
	}
}

void CPekechatDlg::OnConection() 
{
	CConnectionDlg Dlg;
	char Str [500];
	char Buffer [MSG_SIZE];

	if (!Connected)
	{
		Dlg.m_IPAddress = "127.0.0.1";
		Dlg.m_ClientNumber = MAX_USERS;
		Dlg.m_LocalPort = Dlg.m_RemotePort = 5001;
		Dlg.m_NickName = "Boigator";
		if (Dlg.DoModal () == IDOK)
		{
			NickName = Dlg.m_NickName;
			if (Dlg.m_IsServer)
			{
				if (Connection.InitServer (Dlg.m_LocalPort, Dlg.m_ClientNumber) == 0)
				{
					Connection.SetMsgSize (MSG_SIZE);
					m_TextWindow.Empty ();
					wsprintf (Str, "InitServer (%d, %d) --> OK", Dlg.m_LocalPort, Dlg.m_ClientNumber);
					SystemMsg (Str);
					Connected = true;
					SetDlgItemText (IDC_CONECTION, "Desconectar");
					GetDlgItem (IDC_PROMPT_TEXT) -> SetFocus ();
					IsServer = true;
					SetTimer (PEKECHAT_TIMER, 20, NULL);
					wsprintf (Str, "PekeChat 1.0 [SERVIDOR con el nick %s]", NickName);
					SetWindowText (Str);
					UserCount = 1;
					m_NickList.AddString (NickName);
				}
				else
				{
					wsprintf (Str, "%s", Connection.GetErrorMsg ());
					SystemMsg (Str);
				}
			}
			else
			{
				if (Connection.InitClient (Dlg.m_IPAddress, Dlg.m_LocalPort, Dlg.m_RemotePort) == 0)
				{
					Connection.SetMsgSize (MSG_SIZE);
					m_TextWindow.Empty ();
					wsprintf (Str, "InitClient (%s, %d, %d) --> OK", Dlg.m_IPAddress, Dlg.m_LocalPort, Dlg.m_RemotePort);
					SystemMsg (Str);
					Connected = true;
					SetDlgItemText (IDC_CONECTION, "Desconectar");
					GetDlgItem (IDC_PROMPT_TEXT) -> SetFocus ();
					IsServer = false;
					SetTimer (PEKECHAT_TIMER, 20, NULL);
					wsprintf (Str, "PekeChat 1.0 [CLIENTE con el nick %s]", NickName);
					SetWindowText (Str);
					// Send connection request to server
					Buffer [0] = CMSG_CONNECTION_REQUEST;
					Connection.SendToServer (Buffer);
				}
				else
				{
					wsprintf (Str, "%s", Connection.GetErrorMsg ());
					SystemMsg (Str);
				}
			}
		}
	}
	else
	{
		if (IsServer)
		{
			Str [0] = SMSG_SERVER_OFF;
			Connection.SendAllClients (Str);
		}
		else
		{
			Str [0] = CMSG_DISCONNECT;
			strcpy (&Str [1], NickName);
			Connection.SendToServer (Str);
		}
		Connection.ShutDown ();
		Connected = false;
		SetDlgItemText (IDC_CONECTION, "Conectar");
		KillTimer (PEKECHAT_TIMER);
		UserCount = 0;
		m_NickList.ResetContent ();
		m_TextWindow = "Pekechat 1.01 Creado en 2002 por AK47\r\n";
		UpdateData (FALSE);
	}
}

void CPekechatDlg::OnTimer(UINT nIDEvent) 
{
	int ClientId;
	char Buffer [MSG_SIZE];
	int ReturnValue;
	CEdit *pEdit;
	char Str [100];
	char Str2 [100];
	int Count;
	CString NickList;
	char NewNick [100];

	if (Connected)
	{
		if (IsServer)
		{
			ReturnValue = Connection.ReceiveFromClient (Buffer, &ClientId);
			if (ReturnValue != CONNECTION_NO_DATA && ReturnValue == 0)
			{
				// Buffer [0] contains message type
				switch (Buffer [0])
				{
					case CMSG_CONNECTION_REQUEST:
						if (UserCount < MAX_USERS && UserCount - 1 <= ClientId)
						{
							Buffer [0] = SMSG_CONNECTION_ACCEPTED;
							Connection.SendLastClient (Buffer);
						}
						else
						{
							Buffer [0] = SMSG_CONNECTION_DENIED;
							Connection.SendLastClient (Buffer);
						}
						break;
					case CMSG_NICK_SEND:
						if (m_NickList.FindString (0, &Buffer [1]) == LB_ERR)
						{
							m_NickList.AddString (&Buffer [1]);
							strcpy (NewNick, &Buffer [1]); // Copy new nick name
							Connection.AcceptLastClient ();
							memset (Buffer, 0, MSG_SIZE);
							Buffer [0] = SMSG_NICK_ACCEPTED;
							Buffer [1] = m_NickList.GetCount ();
							NickList.Empty ();
							for (Count = 0; Count < m_NickList.GetCount (); Count ++)
							{
								m_NickList.GetText (Count, Str);
								NickList += Str;
								NickList += ";";
							}
							strcpy (&Buffer [2], NickList);
							Connection.SendLastClient (Buffer);
							memset (Buffer, 0, MSG_SIZE);
							Buffer [0] = SMSG_NEW_USER;
							strcpy (&Buffer [1], NewNick);
							Connection.SendAllClients (Buffer, ClientId);
							Connection.GetClientIP (Str2, ClientId);
							wsprintf (Str, "%s se ha unido a la sesion. IP = %s", &Buffer [1], Str2);
							SystemMsg (Str);

							UserCount ++;
						}
						else
						{
							Buffer [0] = SMSG_NICK_DENIED;
							Connection.SendLastClient (Buffer);
						}
						break;
					case CMSG_TEXT:
						if (ClientId >= 0 && ClientId < UserCount - 1)
						{
							UpdateData ();
							m_TextWindow += &Buffer [1];
							m_TextWindow += "\r\n";
							UpdateData (FALSE);
							pEdit = (CEdit *)GetDlgItem (IDC_TEXT_DISPLAY);
							pEdit -> SetSel (m_TextWindow.GetLength (), m_TextWindow.GetLength ());

							Buffer [0] = SMSG_TEXT;
							Connection.SendAllClients (Buffer);
						}
						break;
					case CMSG_DISCONNECT:
						m_NickList.GetText (ClientId + 1, Str);
						m_NickList.DeleteString (ClientId + 1);
						Connection.DeleteClient (ClientId);
						Buffer [0] = SMSG_USER_QUIT;
						strcpy (&Buffer [1], Str);
						Connection.SendAllClients (Buffer);
						wsprintf (Str2, "%s ha abandonado la sesion", Str);
						SystemMsg (Str2);
						UserCount --;
						break;
					/*case CMSG_CONNECTION_LOST:
						m_NickList.GetText (ClientId, Str);
						m_NickList.DeleteString (ClientId);
						Buffer [0] = SMSG_USER_LOST;
						strcpy (&Buffer [1], Str);
						Connection.SendAllClients (Buffer);
						break;*/
				};
			}
		}
		else
		{
			ReturnValue = Connection.ReceiveFromServer (Buffer);
			if (ReturnValue != CONNECTION_NO_DATA && ReturnValue == 0)
			{
				switch (Buffer [0])
				{
					case SMSG_CONNECTION_ACCEPTED:
						memset (Buffer, 0, MSG_SIZE);
						Buffer [0] = CMSG_NICK_SEND;
						strcpy (&Buffer [1], NickName);
						Connection.SendToServer (Buffer);
						break;
					case SMSG_CONNECTION_DENIED:
						SystemMsg ("No se puede conectar con el servidor");
						SetDlgItemText (IDC_CONECTION, "Conectar");
						Connected = false;
						Connection.ShutDown ();
						break;
					case SMSG_NICK_ACCEPTED:
						m_NickList.ResetContent ();
						NickList = &Buffer [2];
						for (Count = 0; Count < Buffer [1]; Count ++)
						{
							m_NickList.AddString (NickList.Left (NickList.Find (";")));
							NickList.Delete (0, NickList.Find (";"));
							NickList.Delete (0);
						}
						wsprintf (Str, "Has iniciado la sesion con el nick %s", NickName);
						SystemMsg (Str);
						break;
					case SMSG_NICK_DENIED:
						wsprintf (Str, "El nick %s no ha sido aceptado por el servidor", NickName);
						SystemMsg (Str);
						SetDlgItemText (IDC_CONECTION, "Conectar");
						Connected = false;
						Connection.ShutDown ();
						break;
					case SMSG_NEW_USER:
						if (m_NickList.FindString (0, &Buffer [1]) == LB_ERR)
						{
							wsprintf (Str, "%s se ha unido a la sesion", &Buffer [1]);
							m_NickList.AddString (&Buffer [1]);
							SystemMsg (Str);
						}
						break;
					case SMSG_USER_QUIT:
						wsprintf (Str, "%s ha abandonado la sesion", &Buffer [1]);
						SystemMsg (Str);
						Count = m_NickList.FindString (0, &Buffer [1]);
						m_NickList.DeleteString (Count);
						break;
					case SMSG_USER_LOST:
						wsprintf (Str, "%s ha perdido la conexion", &Buffer [1]);
						SystemMsg (Str);
						Count = m_NickList.FindString (0, &Buffer [1]);
						m_NickList.DeleteString (Count);
						break;
					case SMSG_TEXT:
						UpdateData ();
						m_TextWindow += &Buffer [1];
						m_TextWindow += "\r\n";
						UpdateData (FALSE);
						pEdit = (CEdit *)GetDlgItem (IDC_TEXT_DISPLAY);
						pEdit -> SetSel (m_TextWindow.GetLength (), m_TextWindow.GetLength ());
						break;
					case SMSG_KICKED:
						SystemMsg ("Has sido expulsado de la sesion");
						SetDlgItemText (IDC_CONECTION, "Conectar");
						Connected = false;
						Connection.ShutDown ();
						m_NickList.ResetContent ();
						break;
					case SMSG_USER_KICKED:
						m_NickList.DeleteString (m_NickList.FindString (0, &Buffer [1]));
						wsprintf (Str, "%s ha sido expulsado de la sesion", &Buffer [1]);
						SystemMsg (Str);
						break;
				};
			}
		}
	}
	
	CDialog::OnTimer(nIDEvent);
}

void CPekechatDlg::SystemMsg (const char *Msg)
{
	CEdit *pEdit;


	UpdateData ();
	m_TextWindow += " ## Sistema: ";
	m_TextWindow += Msg;
	m_TextWindow += " ##\r\n";
	UpdateData (FALSE);
	pEdit = (CEdit *)GetDlgItem (IDC_TEXT_DISPLAY);
	pEdit -> SetSel (m_TextWindow.GetLength (), m_TextWindow.GetLength ());
}

void CPekechatDlg::OnDblclkUserList() 
{
	int ClientId;
	char Buffer [MSG_SIZE];
	char Str [MSG_SIZE];
	char Msg [MSG_SIZE];

	if (Connected && IsServer)
	{
		ClientId = m_NickList.GetCurSel ();

		if (ClientId >= 1)
		{
			Buffer [0] = SMSG_KICKED;
			Connection.SendToClient (Buffer, ClientId - 1);
			Connection.DeleteClient (ClientId - 1);
			UserCount --;
			Buffer [0] = SMSG_USER_KICKED;
			m_NickList.GetText (ClientId, Str);
			strcpy (&Buffer [1], Str);
			Connection.SendAllClients (Buffer);
			m_NickList.DeleteString (ClientId);

			wsprintf (Msg, "%s ha sido expulsado de la sesion", Str);
			SystemMsg (Msg);
		}
	}
}
